unit LDNgraphics1DelphiU1;
//Name derived from fact that this is
// Delphi equivalent of LDNgraphics1, which
// was written to go with...

//http://sheepdogguides.com/lut/lt1Graphics.htm

(*Quick check of grasp of basic graphics, ver 28 Dec 13*)

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls;

type
  TLDNgraphics1DelphiF1 = class(TForm)
    Image1: TImage;
    procedure FormCreate(Sender: TObject);
  private
    Bitmap:TBitmap;
    iImageLeft, iImageTop, iImageWidth, iImageHeight:integer;
   { Private declarations }
  public
    { Public declarations }
  end;

var
  LDNgraphics1DelphiF1: TLDNgraphics1DelphiF1;

implementation

{$R *.DFM}

procedure TLDNgraphics1DelphiF1.FormCreate(Sender: TObject);
begin
iImageLeft:=20;
iImageTop:=10;
iImageWidth:=500;
iImageHeight:=300;

Image1.left:=iImageLeft;
Image1.top:=iImageTop;
Image1.width:=iImageWidth;
Image1.height:=iImageHeight;

Bitmap:=TBitmap.create;//Create a bitmap object
Bitmap.width:=iImageWidth;//Assign dimensions
Bitmap.height:=iImageHeight;

(*Next, assign bitmap to the image...
This had benefits in Delphi... I think it
was to do with getting what you see on
the screen to survive re-sizings, etc.

Some examples of Lazarus graphics on the web
take a different approach... they simply put a bitmap
directly on the main form. They don't bother
with the image... but they also over-ride the
built in "Paint" handler to do it. I haven't
found problems with my "simpler" approach, at
least not under Delphi, and this little
Lazarus "demo" program works.*)

Image1.Picture.Graphic:=Bitmap;//Assign the bitmap to the image component

//That's our drawing surface "prepared".
//Now do some "tricks" with what we have, and learn
//  where "the edges" of the drawable area are...

//From top left, across top
Image1.Picture.Bitmap.canvas.pen.color:=clGreen;
Image1.Picture.Bitmap.canvas.moveto(0,0);
Image1.Picture.Bitmap.canvas.lineto(300,0);

//From top left, along left edge
Image1.Picture.Bitmap.canvas.pen.color:=clRed;
Image1.Picture.Bitmap.canvas.moveto(0,0);
Image1.Picture.Bitmap.canvas.lineto(0,100);

//From bottom right, up right hand edge
//n.b. the "-1" s
Image1.Picture.Bitmap.canvas.pen.color:=clBlack;
Image1.Picture.Bitmap.canvas.moveto(iImageWidth-1,iImageHeight-1);
Image1.Picture.Bitmap.canvas.lineto(iImageWidth-1,50);

//From bottom right, left along bottom edge
//n.b. the "-1" s
Image1.Picture.Bitmap.canvas.pen.color:=clLime;
Image1.Picture.Bitmap.canvas.moveto(iImageWidth-1,iImageHeight-1);
Image1.Picture.Bitmap.canvas.lineto(50,iImageHeight-1);

//Making an individual pixel black...
Image1.Picture.Bitmap.canvas.pixels[10,20] := clBlack;

//Text on a graphic...
//    A variety of "pen" properties can be set
//    before calling...
Image1.Picture.Bitmap.canvas.textout(10,30,'Hello');

end;//FormCreate

end.
